#encoding: utf-8
require "zlogs/version"
require 'logger'

module ZLogs
	##
	# Инициализация логера с appname в logfile
	#
	def self.app_logger_init(appname, logfile)
		nlog=Logger.new(logfile)
		nlog.progname=appname
		#nlog.filename=logfile
		set_app_logger(nlog)#$app_logger
		ilog 'Application logger initialized in file %s'%logfile
	end

	##
	# принудительно меняем логер
	#
	def self.set_app_logger(logger)
		$app_logger=logger
	end

	##
	# логгер по умолчанию
	# 
	def self.null_logger
		$null_logger||=Logger.new(STDERR)
	end

	##
	# получить глобальный объект логера
	def app_logger
		ZLogs::app_logger
	end

	##
	# получить глобальный объект логера
	def self.app_logger
		res_logger= ($app_logger||ZLogs::null_logger)
	end
end
##
# Определяем логирование для всего и вся
# Расширяем Kernel методами работы с логами
module Kernel
	##
	# информационное сообщение в log
	def ilog(*args)
		ZLogs::app_logger.info args.join ' '
	end

	##
	# debug сообщение в log
	def dlog(*args)
		ZLogs::app_logger.debug args.join ' '
	end

	##
	# error сообщение в log
	def elog(*args)
		ZLogs::app_logger.error args.join ' '
	end

	##
	# rescue exception логирование
	# дампим инфу об исключении подробно
	# exc - объект исключения, 
	# msg - дополнительное сообщение
	# 
	def rlog(exc, *msg)
		# формируем сообщение:
		# EXCEPTION exc.class
		# MESSAGE: exc.message
		# TRACE:
		#	exc.backtrace.join("\n\t")
		#  
		strace = exc.backtrace||[]
		exc||=Exception.new('<NULL EXCEPTION PASSED>')
		dbg_msg="<<EXC# %s: %s>>
	MESSAGE: %s
	TRACE:
		%s"
		dlog (dbg_msg%[exc.class, exc.message, msg.join(' '), strace.join("\n\t\t")]).gsub(/^\s*[A-Z]+:\s*$/,'')
		err_msg="Exception from [%s]: %s (%s)"
		elog err_msg%[strace.first, exc.message, exc.class]
	end

end
